/* 
   $Id: Nnm.h,v 1.1.1.1 2005/06/29 22:24:19 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 *	NuNoMe Project - NuNoMe Common Header File
 *		Nnm Use File Structure
 *
 */
#ifndef NNM_H
#define NNM_H

#define MAX_STR_LEN	2048
#define	uchar	unsigned char
#define ushort	unsigned short
#define uint	unsigned int
#define	ulong	unsigned long

#define ABS(x)		( ( (x)>0 )? (x):-(x) )
#define MAX(a,b)	( ((a)>(b))? (a):(b) )
#define MIN(a,b)	( ((a)<(b))? (a):(b) )

/* Canvas */
#ifndef NnmCANVAS_DISPLAY_SIZE
#define NnmCANVAS_DISPLAY_SIZE	64	/* Display Canvas Window size */
#endif
#ifndef NnmCANVAS_INNER_SIZE
#define NnmCANVAS_INNER_SIZE	64	/* Inner Canvas size */
#endif
#define NnmMaxSTROKE_NUM	30	/* Number of Strokes at one character */
#define NnmMaxSTROKE_LEN	3*NnmCANVAS_INNER_SIZE /* Number of Sampling points at one stroke */
#define NnmStdSTROKE_LEN	NnmCANVAS_INNER_SIZE

/* PreProcess */
#define NnmSMOOTH_THRES		16
#define NnmNOISE_THRES		8
#define NnmNLFIXCONST		6  // (ȥ)
#define NnmNL_LINEAR		1  // (ܶ)

typedef struct {
  uchar		len;
  uchar		sample_x[NnmMaxSTROKE_LEN+1];
  uchar		sample_y[NnmMaxSTROKE_LEN+1];
}	NnmRawStrokeRec;	/* 1ȥΥץǡ */

typedef struct 
{
  uchar		len;
  uchar		sample_x[NnmStdSTROKE_LEN+1];
  uchar		sample_y[NnmStdSTROKE_LEN+1];
}	NnmStrokeRec;		/* Noiseless,Normalized ȥ */


typedef struct
{
  char	num;
  uchar	width, height;
  NnmStrokeRec	stroke[NnmMaxSTROKE_NUM+1];
}	NnmCharInfoRec;		/* ʸǡ */

typedef struct
{
  char		num;
  uchar		width, height;
  NnmRawStrokeRec	stroke[NnmMaxSTROKE_NUM+1];
}	NnmRawCharInfoRec;		/* ʸǡ */

/* ʸϰ */
typedef struct{
  ulong	st;
  ulong	ed;
}	CodeSet;

/* ǧ */

#ifndef MAX_CANDIDATE_CATEGORY
#define MAX_CANDIDATE_CATEGORY	50	/* 䥫ƥ */
#endif

typedef struct{
  ulong	code;
  int	dicfd;
  long	fptr;
  ulong	cand_score;
  ulong	recog_score;
}	NnmCandidateRec;

#define	MAX_DISP_RESULT	6
#define	MAX_NUM_CANVAS	2

#define DISP_CAND_ROW		6
#define DISP_CAND_COLUMN	4
#define MAX_DISP_CANDIDATE	(DISP_CAND_ROW*DISP_CAND_COLUMN)

#endif	/* NNM_H */
