/* 
   $Id: NnmCandidate.c,v 1.1.1.1 2005/06/29 22:24:19 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include "Nnm.h"
#include "NnmFeature.h"
#include "NnmProto.h"


void	NnmAllStrokeDirection( NnmFeatureRec *fv )
{
  int	dir;
  int	x, y, sum;

  for( dir=0; dir<8; dir++ ){
    sum = 0;
    for( y=0; y<NnmREGION_NUM_Y; y++){
      for( x=0; x<NnmREGION_NUM_X; x++ ){
	sum += fv->dir_fv[dir][y][x];
      }
    }
    fv->Cand.dir_stroke[dir] = MIN( 255, sum/8 );
  }
}


#ifdef CAND_TEST
int	NnmCandidateFeature( NnmCharInfoRec *charInfo, 
			     NnmRawFeatureRec *rawfv )
{
  int	strk, len, dir1, dir2, dir, i, j;
  int	sx, sy, ex, ey, dx, dy, dd;
  int	short_th, long_th;
  int	sxpos, sypos, sxypos, syxpos;

  long_th = NnmCANVAS_INNER_SIZE/3;
  long_th = long_th*long_th;
  short_th = NnmCANVAS_INNER_SIZE*2;
  short_th /= 3;
  short_th = short_th*short_th;
  for( dir=0; dir<8; dir++ ){
    for( i=0; i<NnmCAND_SPLIT_NUM; i++ ){
      rawfv->Cand.strkLong[dir][i] = 0;
#ifdef CAND_TEST2
      for( j=0; j<NnmCAND_SPLIT_NUM; j++ ){
	rawfv->Cand.strkShort[dir][i][j] = 0;
      }
#else
      rawfv->Cand.strkLong[dir][i] = 0;
      rawfv->Cand.strkShort[dir][i] = 0;
#endif
    }
  }
  for( strk=0; strk<charInfo->num; strk++ ){
    len = charInfo->stroke[strk].len;
    sx = charInfo->stroke[strk].sample_x[0];
    sy = charInfo->stroke[strk].sample_y[0];
    ex = charInfo->stroke[strk].sample_x[len-1];
    ey = charInfo->stroke[strk].sample_y[len-1];
    dx = ex - sx;
    dy = ey - sy;
    dd = dx*dx + dy*dy;
    if ( dd==0 ) continue;

    sxpos = sx*NnmCAND_SPLIT_NUM;
    sxpos /= NnmCANVAS_INNER_SIZE;

    sypos = sy*NnmCAND_SPLIT_NUM ;
    sypos /= NnmCANVAS_INNER_SIZE;

    sxypos = (sx+sy)*NnmCAND_SPLIT_NUM;
    sxypos /= 2*NnmCANVAS_INNER_SIZE;

    syxpos = (sx-sy+NnmCANVAS_INNER_SIZE)*NnmCAND_SPLIT_NUM;
    syxpos /= 2*NnmCANVAS_INNER_SIZE;

    dir1 = StrokeDirection1( dx, dy );
    dir2 = StrokeDirection2( dx, dy );
    if ( (dir1==-1)&&(dir2==-1) ) continue;
    
    if ( dd > long_th ){
      switch ( dir1 ){
      case 0:	//	Right
      case 4:	//	Left
	//	spos = sx*NnmCAND_SPLIT_NUM / NnmCANVAS_INNER_SIZE;
	//	rawfv->Cand.strkLong[dir1][spos]++;
	rawfv->Cand.strkLong[dir1][sxpos]++;
	break;
      case 2:	//	Up
      case 6:	//	Down
	//	spos = sy*NnmCAND_SPLIT_NUM / NnmCANVAS_INNER_SIZE;
	//	rawfv->Cand.strkLong[dir1][spos]++;
	rawfv->Cand.strkLong[dir1][sypos]++;
	break;
      default:
	break;
      }
      switch ( dir2 ){
      case 1:	//	Right
      case 5:	//	Left
	//	spos = (sx-sy+NnmCANVAS_INNER_SIZE)*NnmCAND_SPLIT_NUM / (2*NnmCANVAS_INNER_SIZE);
	//	rawfv->Cand.strkLong[dir2][spos]++;
	rawfv->Cand.strkLong[dir2][syxpos]++;
	break;
      case 3:	//	Up
      case 7:	//	Down
	//	spos = (sx+sy)*NnmCAND_SPLIT_NUM / (2*NnmCANVAS_INNER_SIZE);
	//	rawfv->Cand.strkLong[dir2][spos]++;
	rawfv->Cand.strkLong[dir2][sxypos]++;
	break;
      default:
	break;
      }
    }
    if ( dd < short_th ){
      switch ( dir1 ){
      case 0:	//	Right
      case 4:	//	Left
	//	spos = sx*NnmCAND_SPLIT_NUM / NnmCANVAS_INNER_SIZE;
	//	rawfv->Cand.strkShort[dir1][spos]++;
#ifdef CAND_TEST2
	rawfv->Cand.strkShort[dir1][sxpos][sypos]++;
#else
	rawfv->Cand.strkShort[dir1][sxpos]++;
#endif
	break;
      case 2:	//	Up
      case 6:	//	Down
	//	spos = sy*NnmCAND_SPLIT_NUM / NnmCANVAS_INNER_SIZE;
	//	rawfv->Cand.strkShort[dir1][spos]++;
#ifdef CAND_TEST2
	rawfv->Cand.strkShort[dir1][sxpos][sypos]++;
#else
	rawfv->Cand.strkShort[dir1][sypos]++;
#endif
	break;
      default:
	break;
      }
      switch ( dir2 ){
      case 1:	//	Right
      case 5:	//	Left
	//	spos = (sx-sy+NnmCANVAS_INNER_SIZE)*NnmCAND_SPLIT_NUM / (2*NnmCANVAS_INNER_SIZE);
	//	rawfv->Cand.strkShort[dir2][spos]++;
#ifdef CAND_TEST2
	rawfv->Cand.strkShort[dir2][sxpos][sypos]++;
#else
	rawfv->Cand.strkShort[dir2][syxpos]++;
#endif
	break;
      case 3:	//	Up
      case 7:	//	Down
	//	spos = (sx+sy)*NnmCAND_SPLIT_NUM / (2*NnmCANVAS_INNER_SIZE);
	//	rawfv->Cand.strkShort[dir2][spos]++;
#ifdef CAND_TEST2
	rawfv->Cand.strkShort[dir2][sxpos][sypos]++;
#else
	rawfv->Cand.strkShort[dir2][sxypos]++;
#endif
	break;
      default:
	break;
      }
    }
  }
  return 0;
}

#endif




