/* 
   $Id: NnmFeature.c,v 1.1.1.1 2005/06/29 22:24:21 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include "Nnm.h"
#include "NnmFeature.h"
#include "NnmProto.h"

static	int	NnmFVBlurConst[NnmFV_REGION_HEIGHT][NnmFV_REGION_WIDTH]={
  { 1, 3, 3, 1 },
  { 3, 9, 9, 3 },
  { 3, 9, 9, 3 },
  { 1, 3, 3, 1 }
};

static int NnmFVBlurConstSum = 64;

/* 
 * ȥ
 *    deg: 0, 90, 180, 270
 */
int	StrokeDirection1( int dx, int dy )
{
  int	absdx, absdy;
  
  absdx = ABS( dx );
  absdy = ABS( dy );
  /*
   *	>=,<=Υϸľۤ
   */
  if ( (dx > 0)&&
       (absdx*NnmDIR1_SCALE1 > absdy*NnmDIR1_SCALE2) ){ /* Right */
    return 0;
  }else if ( (dy > 0)&&
	     (absdy*NnmDIR1_SCALE1 > absdx*NnmDIR1_SCALE2) ){ /* Up */
    return 2;
  }else if ( (dx < 0)&&
	     (absdx*NnmDIR1_SCALE1 > absdy*NnmDIR1_SCALE2) ){ /* Left */
    return 4;
  }else if ( (dy < 0)&&
	     (absdy*NnmDIR1_SCALE1 > absdx*NnmDIR1_SCALE2) ){ /* Down */
    return 6;
  }
  return -1;
}


/* 
 * ȥ
 *    deg: 45, 135, 225, 315
 */
int	StrokeDirection2( int dx, int dy )
{
  int	absdx, absdy;
  
  absdx = ABS( dx );
  absdy = ABS( dy );
  /*
   *	>=,<=Υϸľۤ
   */
  if ( (dx > 0)&&(dy > 0)&&
       (absdy*NnmDIR2_SCALE1 > absdx*NnmDIR2_SCALE2)&&
       (absdx*NnmDIR2_SCALE1 > absdy*NnmDIR2_SCALE2) ){ /* Right Up */
    return 1;
  }else if ( (dx < 0)&&(dy > 0)&&
	     (absdy*NnmDIR2_SCALE1 > absdx*NnmDIR2_SCALE2)&&
	     (absdx*NnmDIR2_SCALE1 > absdy*NnmDIR2_SCALE2) ){ /* Left Up */
    return 3;
  }else if ( (dx < 0)&&(dy < 0)&&
	     (absdy*NnmDIR2_SCALE1 > absdx*NnmDIR2_SCALE2)&&
	     (absdx*NnmDIR2_SCALE1 > absdy*NnmDIR2_SCALE2) ){ /* Right Up */
    return 5;
  }else if ( (dx > 0)&&(dy < 0)&&
	     (absdy*NnmDIR2_SCALE1 > absdx*NnmDIR2_SCALE2)&&
	     (absdx*NnmDIR2_SCALE1 > absdy*NnmDIR2_SCALE2) ){ /* Right Up */
    return 7;
  }
  return -1;
}


/*
 *	ħ̤ʬ
 *		Ūȥξ
 */
static	int	DivideVectorX( NnmRawFeatureRec *fv, int dir1, int dir2,
			       int sx, int sy, int ex, int ey )
{
  int	x, y;
  int	ix, iy;
  int	res;
  
  res = 0;
  if ( sx<ex ){
    for( x=sx; x<=ex; x++ ){
      y = (ey-sy)*(x-sx);
      y = sy+y/(ex-sx);
      ix =  x*NnmREGION_NUM_X;
      ix /= NnmCANVAS_INNER_SIZE;
      iy =  y*NnmREGION_NUM_Y;
      iy /= NnmCANVAS_INNER_SIZE;

      if ( dir1!=-1 ) fv->dir_fv[dir1][iy][ix]++;
      if ( dir2!=-1 ) fv->dir_fv[dir2][iy][ix]++;
      res++;
    }
  }else if ( sx>ex ) {
    for( x=ex; x<=sx; x++ ){
      y = (ey-sy)*(x-sx);
      y = sy+y/(ex-sx);      
      ix =  x*NnmREGION_NUM_X;
      ix /= NnmCANVAS_INNER_SIZE;
      iy =  y*NnmREGION_NUM_Y; 
      iy /= NnmCANVAS_INNER_SIZE;

      if ( dir1!=-1 ) fv->dir_fv[dir1][iy][ix]++;
      if ( dir2!=-1 ) fv->dir_fv[dir2][iy][ix]++;
      res++;
    }
  }else{	/* sx==ex */
    fprintf(stderr,"Unexpect Error in DivideVectorX() in feature.c\n");
  }
  return res;
}


/*
 *	ħ̤ʬ
 *		Ūȥξ
 */
static	int	DivideVectorY( NnmRawFeatureRec *fv, int dir1, int dir2,
			       int sx, int sy, int ex, int ey )
{
  int	x, y;
  int	ix, iy;
  int	res;
  
  res = 0;
  if ( sy<ey ){
    for( y=sy; y<=ey; y++ ){
      x =  (ex-sx)*(y-sy);
      x = sx+x/(ey-sy);
      ix =  x*NnmREGION_NUM_X;
      ix /= NnmCANVAS_INNER_SIZE;
      iy =  y*NnmREGION_NUM_Y;
      iy /= NnmCANVAS_INNER_SIZE;
      
      if ( dir1!=-1 ) fv->dir_fv[dir1][iy][ix]++;
      if ( dir2!=-1 ) fv->dir_fv[dir2][iy][ix]++;
      res++;
    }
  }else if ( sy>ey ){
    for( y=ey; y<=sy; y++ ){
      x = (ex-sx)*(y-sy);
      x = sx+x/(ey-sy);
      ix =  x*NnmREGION_NUM_X; 
      ix /= NnmCANVAS_INNER_SIZE;
      iy =  y*NnmREGION_NUM_Y;
      iy /= NnmCANVAS_INNER_SIZE;
      if ( dir1!=-1 ) fv->dir_fv[dir1][iy][ix]++;
      if ( dir2!=-1 ) fv->dir_fv[dir2][iy][ix]++;
      res++;
    }
  }else{	/* sy==ey */
    fprintf(stderr,"Unexpect Error in DivideVectorY() in feature.c\n");
  }
  return res;
}

/*
 *	ħ̤Τܤܼ︺(ΰΤ餷Ť)
 *
 */
static	void	NnmFeatureBlurring( NnmRawFeatureRec *rawfv, 
				    NnmFeatureRec *fv )
{
  int		x, y, d, ix, iy, sum, xx, yy;
  int		tmp;

  memcpy( &(fv->Cand), &(rawfv->Cand), sizeof(NnmCandFeatureRec) );
  for( d=0; d<8; d++ ){
    for( y=0; y<NnmFV_REGION_Y; y++ ){
      for( x=0; x<NnmFV_REGION_X; x++ ){
	sum = 0;
	for( iy=0; iy<NnmFV_REGION_HEIGHT; iy++ ){
	  yy = y*NnmREGION_STEP_Y+iy;
	  if ( (yy<0)||(yy>=NnmREGION_NUM_Y) ) continue;
	  for( ix=0; ix<NnmFV_REGION_WIDTH; ix++ ){
	    xx = x*NnmREGION_STEP_X+ix;
	    if ( (xx<0)||(xx>=NnmREGION_NUM_Y) ) continue;
	    sum += rawfv->dir_fv[d][yy][xx]*NnmFVBlurConst[iy][ix];
	  }
	}
	
	tmp = sum*4;
	fv->dir_fv[d][y][x] = tmp/NnmFVBlurConstSum;
      }
    }
  }
#ifdef DEBUG_PRINT
  for( d=0; d<8; d++ ){
    fprintf(stderr," DIR %1d\n", d );
    fprintf(stderr,"   dir_stroke %d\n",fv->Cand.dir_stroke[d] );
    for( y=0; y<NnmFV_REGION_Y; y++ ){
      for( x=0; x<NnmFV_REGION_X; x++ ){
	fprintf(stderr,"%4d", fv->dir_fv[d][y][x] );
      }
      fprintf(stderr,"\n");
    }
  }
#endif
}


/*
 *  ŪʥȥȤħȤ
 *
 */
static	void	NnmStrokeDirection( NnmRawFeatureRec *rawfv, int *strkd )
{
  int	i, maxd, maxv;

#ifdef NODEF	// 01FEB26:¸̤
  for( i=0; i<4; i++ ){
    if ( strkd[i] > strkd[i+4] ){
      strkd[i]   = strkd[i] - strkd[i+4];
      strkd[i+4] = 0;
    }else{
      strkd[i+4] = strkd[i+4] - strkd[i];
      strkd[i]   = 0;
    }
  }
#endif
  maxv = maxd = 0;
  for( i=0; i<8; i++ ){
    if ( maxv < strkd[i] ){
      maxv = strkd[i];
      maxd = i;
    }
  }
#define NnmCAND_STRK_TH	3	// 01FEB26¸
  for( i=0; i<8; i++ ){
#ifndef NODEF			// 01FEB26¸
    if ( strkd[i] >= maxv/NnmCAND_STRK_TH ){
#else
    if ( strkd[i] >= NnmCANVAS_INNER_SIZE/NnmCAND_STRK_TH ){
#endif
      rawfv->Cand.dir_stroke[i]++;
    }
  }
}



/*
 *	ȥץ󤫤8ħ̤ؤѴ
 */
void	NnmCharinfoToRawFeature( NnmCharInfoRec *charInfo,
				 NnmRawFeatureRec *rawfv )
{
  int			strk, spt;
  int			ix, iy;
  int			direct,dir1, dir2;
  int			strkd[8], dval;

  rawfv->Cand.num_stroke = charInfo->num;
  rawfv->Cand.sizeX      = charInfo->width;
  rawfv->Cand.sizeY      = charInfo->height;
  for( direct=0; direct<8; direct++ ){
    rawfv->Cand.dir_stroke[direct] = 0;
    for( iy=0; iy<NnmREGION_NUM_Y; iy++ ){
      for( ix=0; ix<NnmREGION_NUM_X; ix++ ){
	rawfv->dir_fv[direct][iy][ix] = 0;
      }
    }
  }
#ifdef CAND_TEST
  NnmCandidateFeature( charInfo, rawfv );
#endif
  for( strk=0; strk<charInfo->num; strk++ ){
    strkd[0] = strkd[1] = strkd[2] = strkd[3] =
      strkd[4] = strkd[5] = strkd[6] = strkd[7] = 0;
    for( spt=1; spt<charInfo->stroke[strk].len; spt++ ){
      int	x1,x2,y1,y2, dx,dy;

      x1 = charInfo->stroke[strk].sample_x[spt-1];
      x2 = charInfo->stroke[strk].sample_x[spt  ];
      y1 = charInfo->stroke[strk].sample_y[spt-1];
      y2 = charInfo->stroke[strk].sample_y[spt  ];
#define ERR_CHECK
#ifdef ERR_CHECK
      if ( (x1<0)||(y1<0)||(x2<0)||(y2<0)||
	   (x1>=NnmCANVAS_INNER_SIZE)||
	   (x2>=NnmCANVAS_INNER_SIZE)||
	   (y1>=NnmCANVAS_INNER_SIZE)||
	   (y2>=NnmCANVAS_INNER_SIZE) ){
	fprintf( stderr,"strk %3d: spt %3d: Range:(%4d,%4d,%4d,%4d)\n",
		 strk, spt, x1,y1,x2,y2);
      }
#endif
      dx = x2 - x1;
      dy = y2 - y1;
      if ( (dx==0)&&(dy==0) ) continue;
      dir1 = StrokeDirection1( dx, dy );
      dir2 = StrokeDirection2( dx, dy );
      if ( (dir1==-1)&&(dir2==-1) ) continue;
      if ( ABS(dx)>ABS(dy) ){
	dval = DivideVectorX( rawfv, dir1, dir2, x1, y1, x2, y2 );
      }else{
	dval = DivideVectorY( rawfv, dir1, dir2, x1, y1, x2, y2 );
      }
      if (dir1 >= 0) strkd[dir1] += dval;
      if (dir2 >= 0) strkd[dir2] += dval;
    }
    NnmStrokeDirection( rawfv, strkd );
  }
#ifdef DEBUG_PRINT
  fprintf(stderr,"Feature\n");
  fprintf(stderr," Stroke = %3d : size = (%4d,%4d)\n",
	 rawfv->Cand.num_stroke, rawfv->Cand.sizeX, rawfv->Cand.sizeY );
  for( direct=0; direct<8; direct++ ){
    fprintf(stderr,"Direct:%2d\n",direct);
    for( iy=0; iy<NnmREGION_NUM_Y; iy++ ){
      for( ix=0; ix<NnmREGION_NUM_X; ix++ ){
	fprintf(stderr," %4d ", rawfv->dir_fv[direct][iy][ix] );
      }
      fprintf(stderr,"\n");
    }
  }
#endif
}


/*
 *  ħ
 *	ץ󥰥ࡼ
 *	Υ
 *	ƥץ
 *	
 *	ħ
 *	ħ︺
 */
int	NnmConvertCharInfoToFeature( NnmRawCharInfoRec *charInfo,
				     NnmCharInfoRec *ci,
				     NnmFeatureRec *fv )
{
  NnmRawFeatureRec	rawfv;

  NnmNormalizeCharInfo( charInfo, ci );
  /* 8 directional feature */
  NnmCharinfoToRawFeature( ci, &rawfv );
  NnmFeatureBlurring( &rawfv, fv );
  return 0;
}

void NnmFeatureToFeatureDic(long code, NnmFeatureRec *fv,
  NnmFeatureDicRec *stdfv)
{
    int dir,x,y;
    NnmCandFeatureRec *cand;
    NnmCandFeatureDicRec *stdCand;

    stdfv->num_sample = 1;
    stdfv->code = code;
    stdCand = &(stdfv->Cand);
    cand = &(fv->Cand);
    stdCand->num_stroke = cand->num_stroke;
    stdCand->sizeX = cand->sizeX;
    stdCand->sizeY = cand->sizeY;
    for (dir = 0;dir < 8;dir++) {
	stdCand->dir_stroke[dir] = cand->dir_stroke[dir];
#ifdef NNM_WEIGHT
	stdCand->dir_stroke_weight[dir] = NNM_WEIGHT_STD;
#endif
#ifdef CAND_TEST
	for (x = 0;x < NnmCAND_SPLIT_NUM;x++) {
	    stdCand->strkLong[dir][x] = cand->strkLong[dir][x];
#ifdef CAND_TEST2
	    for (y = 0;y < NnmCAND_SPLIT_NUM;y++) {
		stdCand->strkShort[dir][y][x] =
		   cand->strkShort[dir][y][x];
	    }
#else
	    stdCand->strkShort[dir][x] = cand->strkShort[dir][x];
#endif
	}
#endif
	for (y = 0;y < NnmFV_REGION_Y;y++) {
	    for (x = 0;x < NnmFV_REGION_X;x++) {
		stdfv->dir_fv[dir][y][x] = fv->dir_fv[dir][y][x];
#ifdef NNM_WEIGHT
		stdfv->weight[dir][y][x] = NNM_WEIGHT_STD;
#endif
	    }
	}
    }
}

void NnmUpdateFeatureDic(NnmFeatureRec *fv, NnmFeatureDicRec *stdfv)
{
    int	d, x, y, mi, mj;
    long tmp;
    long half;
    unsigned long num_sample;

    if (stdfv->num_sample >= 0xff0000) stdfv->num_sample--;
    num_sample = stdfv->num_sample+1;
    half = num_sample/2;
    tmp = (int)stdfv->Cand.sizeX*stdfv->num_sample +
			(int)fv->Cand.sizeX+half;
    stdfv->Cand.sizeX = tmp/num_sample;
    tmp = (int)stdfv->Cand.sizeY*stdfv->num_sample +
			(int)fv->Cand.sizeY+half;
    stdfv->Cand.sizeY = tmp/num_sample;
    tmp = (int)stdfv->Cand.num_stroke*stdfv->num_sample +
		       (int)fv->Cand.num_stroke+half;
    stdfv->Cand.num_stroke = tmp/num_sample;
    for( d=0; d<8; d++ ){
#ifdef CAND_TEST
      for( mi=0; mi<NnmCAND_SPLIT_NUM; mi++ ){
	tmp = (int)stdfv->Cand.strkLong[d][mi]*stdfv->num_sample +
	   (int)fv->Cand.strkLong[d][mi]+half;
	stdfv->Cand.strkLong[d][mi] = tmp/num_sample;
#ifdef CAND_TEST2
	for( mj=0; mj<NnmCAND_SPLIT_NUM; mj++ ){
	  tmp = (int)stdfv->Cand.strkShort[d][mi][mj]*stdfv->num_sample +
	     (int)fv->Cand.strkShort[d][mi][mj]+half;
	  stdfv->Cand.strkShort[d][mi][mj] = tmp/num_sample;
	}
#else
	tmp = (int)stdfv->Cand.strkShort[d][mi]*stdfv->num_sample +
	   (int)fv->Cand.strkShort[d][mi]+half;
	stdfv->Cand.strkShort[d][mi] = tmp/num_sample;
#endif	// CAND_TEST2
      }
#endif	// CAND_TEST
      tmp = (int)stdfv->Cand.dir_stroke[d]*stdfv->num_sample +
	 (int)fv->Cand.dir_stroke[d]+half;
      stdfv->Cand.dir_stroke[d] = tmp/num_sample;
#ifdef NNM_WEIGHT
      stdfv->Cand.dir_stroke_weight[d] = NNM_WEIGHT_STD;
#endif
      for( y=0; y<NnmFV_REGION_Y; y++ ){
	for( x=0; x<NnmFV_REGION_X; x++ ){
	  tmp = (int)stdfv->dir_fv[d][y][x]*stdfv->num_sample +
		   (int)fv->dir_fv[d][y][x]+half;
	  stdfv->dir_fv[d][y][x] = tmp/num_sample;
#ifdef NNM_WEIGHT
	  stdfv->weight[d][y][x] = NNM_WEIGHT_STD;
#endif
	}
      }
    }
    stdfv->num_sample++;
}
