/* 
   $Id: NnmProto.h,v 1.1.1.1 2005/06/29 22:24:21 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef NNM_PROTO_H
#define NNM_PROTO_H

#include "Nnm.h"
#include "NnmFeature.h"

// NnmCandidate.c
void	NnmAllStrokeDirection( NnmFeatureRec *fv );
int	NnmCandidateFeature( NnmCharInfoRec *charInfo, 
			     NnmRawFeatureRec *rawfv );

// NnmCompare.c
int	NnmSetDictionaryFile( char *fn, int user);
int NnmUpdateUserDictionary(long code, NnmFeatureRec *fv);
void NnmSetCandidateParam(int size, int strLong, int strShort,
  int res, int strDis);
ulong	NnmRecognizeCharacterInfo( NnmRawCharInfoRec *RawCharInfo,
				   NnmCandidateRec *cands, int num_cands,
				   NnmFeatureRec *fv, FILE *monfp, ulong code );
ulong	NnmRecognizeCharInfo( NnmRawCharInfoRec *charInfo, 
			      NnmCandidateRec *cands, int num_cands,
			      NnmFeatureRec *fv);
ulong NnmDetailRecognize( NnmFeatureRec *fv, NnmCandidateRec *cands,
				 int num_cands, FILE *monfp, ulong code );
void NnmRefreshDicCache(void);

// NnmFeature.c
int	StrokeDirection1( int dx, int dy );
int	StrokeDirection2( int dx, int dy );
void	NnmCharinfoToRawFeature( NnmCharInfoRec *charInfo,
				 NnmRawFeatureRec *rawfv );
int	NnmConvertCharInfoToFeature( NnmRawCharInfoRec *charInfo,
				     NnmCharInfoRec *ci,
				     NnmFeatureRec *fv );
void	NnmFeatureToFeatureDic(long code, NnmFeatureRec *fv,
			      NnmFeatureDicRec *stdfv);
void	NnmUpdateFeatureDic(NnmFeatureRec *fv, NnmFeatureDicRec *stdfv);

// NnmNormalize.c
int	NnmNormalizeCharInfo( NnmRawCharInfoRec *rawci,
			      NnmCharInfoRec *ci );
void	NnmRawStrokeSmoothing( NnmRawStrokeRec *src,
				       NnmRawStrokeRec *dst );
void	NnmRawStrokeRemoveNearly( NnmRawStrokeRec *src,
					  NnmRawStrokeRec *dst );
void	NnmRawStrokeResampling( NnmRawStrokeRec *src,
					NnmStrokeRec *dst );
void	NnmNonlinearNormalize( NnmCharInfoRec *charInfo );

// NnmUtil.c
void	NnmCandidateSorting( NnmCandidateRec *cands, int num,
			     NnmCandidateRec **scands );
void	NnmCandidateSortingWithCandScore( NnmCandidateRec *cands,
					  int num, NnmCandidateRec **scands );
int	NnmNumberOfDictionary( char *dicfn );
int	NnmInitDicCache( char *dicfn, NnmDicCache *cp, int user);
void	NnmAppendDicCache(NnmDicCache *cp, NnmFeatureDicRec*stdfv);
void	NnmClearDicCache(NnmDicCache *cp);


// NNmfile.c
int	NnmFSize( char *fn);
int	NnmFOpen( char *fn, char *mode );
size_t	NnmFRead( void *ptr, size_t size, size_t nmemb, int fd );
size_t	NnmFWrite( void *ptr, size_t size, size_t nmemb, int fd );
int	NnmFClose( int fd );
long	NnmFSeek( int fd, long offset, int whence );
long	NnmFTell( int fd );
int	NnmFEof( int fd );
int	NnmSampleAppendFile( NnmRawCharInfoRec *rawCharInfo, ulong code, 
			     char *fn );
int	NnmSampleReadFile( NnmRawCharInfoRec *rawCharInfo, ulong *code, ulong infd );
int	NnmSampleRemoveFile( int infd, long fptr );
int	NnmReadStandardFeature( int fd, NnmFeatureDicRec *fv );
int	NnmWriteStandardFeature( int fd, NnmFeatureDicRec *fv );

#endif
