/* 
   $Id: NnmSortCand.c,v 1.1.1.1 2005/06/29 22:24:22 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "Nnm.h"
#include "NnmFeature.h"
#include "NnmProto.h"

static	int	NnmSortCompare( NnmCandidateRec *p1,
				NnmCandidateRec *p2 )
{
  if ( p1->recog_score > p2->recog_score ) return 1;
  else if ( p1->recog_score < p2->recog_score ) return -1;
  else return 0;
}


static	int	NnmSortCompareWithCandScore( NnmCandidateRec *p1,
					     NnmCandidateRec *p2 )
{
  if ( p1->cand_score > p2->cand_score ) return 1;
  else if ( p1->cand_score < p2->cand_score ) return -1;
  else return 0;
}


void	NnmCandidateSorting( NnmCandidateRec *cands, int num,
			     NnmCandidateRec **scands )
{
  int	i, done;
  
  for( i=0; i<num; i++ ){
    scands[i] = &(cands[i]);
  }
  for( done=1; done==1; ){
    done = 0;
    for( i=1; i<num; i++ ){
      if ( NnmSortCompare( scands[i-1], scands[i] )>0 ){
	NnmCandidateRec	*tmp;
	
	tmp         = scands[i];
	scands[i]   = scands[i-1];
	scands[i-1] = tmp;
	done = 1;
      }
    }
  }
}



void	NnmCandidateSortingWithCandScore( NnmCandidateRec *cands,
					  int num, NnmCandidateRec **scands )
{
  int	i, done;
  
  for( i=0; i<num; i++ ){
    scands[i] = &(cands[i]);
  }
  for( done=1; done==1; ){
    done = 0;
    for( i=1; i<num; i++ ){
      if ( NnmSortCompareWithCandScore( scands[i-1], scands[i] )>0 ){
	NnmCandidateRec	*tmp;
	
	tmp         = scands[i];
	scands[i]   = scands[i-1];
	scands[i-1] = tmp;
	done = 1;
      }
    }
  }
}

