/* 
   $Id: NnmFeature.h,v 1.1.1.1 2005/06/29 22:24:41 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 *		Extract Feature Vector
 *
 */
#ifndef NNM_FEATURE_H
#define NNM_FEATURE_H
#include "Nnm.h"

#define NnmDIR1_SCALE1		2
#define NnmDIR1_SCALE2		3
#define NnmDIR2_SCALE1		4
#define NnmDIR2_SCALE2		1

#define NnmREGION_NUM_X		16	/* ︺ΰʬ */
#define NnmREGION_NUM_Y		16
#define NnmFV_REGION_X		7	/* ̸ΰʬ */
#define NnmFV_REGION_Y		7
#define	NnmFV_REGION_WIDTH	4    	/*  */
#define	NnmFV_REGION_HEIGHT	4
#define	NnmREGION_STEP_X	2
#define	NnmREGION_STEP_Y	2

#define NnmDIC_TIMES_CONST	16

#define	CAND_TEST
#define CAND_TEST2	//Short2Ϥ褫ä(01Mar08)

#ifdef CAND_TEST
#define NnmCAND_SPLIT_NUM	3	// 2Ϥ褯ʤä(01Mar08)
#endif

typedef struct{
  uchar num_stroke;
  uchar	sizeX, sizeY;
  uchar	dir_stroke[8];
#ifdef CAND_TEST
  uchar	strkLong[8][NnmCAND_SPLIT_NUM];
#ifdef CAND_TEST2
  uchar	strkShort[8][NnmCAND_SPLIT_NUM][NnmCAND_SPLIT_NUM];
#else
  uchar	strkShort[8][NnmCAND_SPLIT_NUM];
#endif
#endif
}	NnmCandFeatureRec;

typedef struct{
  uchar num_stroke;
  uchar	sizeX, sizeY;
  uchar	dir_stroke[8];
#ifdef NNM_WEIGHT
  uchar	dir_stroke_weight[8];
#endif
#ifdef CAND_TEST 
  uchar	strkLong[8][NnmCAND_SPLIT_NUM];
#ifdef CAND_TEST2
  uchar	strkShort[8][NnmCAND_SPLIT_NUM][NnmCAND_SPLIT_NUM];
#else
  uchar	strkShort[8][NnmCAND_SPLIT_NUM];
#endif
#endif
}	NnmCandFeatureDicRec;

#ifdef CAND_TEST
#define CAND_STRLONG_DIC_SIZE (sizeof(uchar)*8*NnmCAND_SPLIT_NUM)
#ifdef CAND_TEST2
#define CAND_STRSHORT_DIC_SIZE (sizeof(uchar)*8*NnmCAND_SPLIT_NUM*NnmCAND_SPLIT_NUM)
#else
#define CAND_STRSHORT_DIC_SIZE (sizeof(uchar)*8*NnmCAND_SPLIT_NUM)
#endif
#else
#define CAND_STRLONG_DIC_SIZE 0
#define CAND_STRSHORT_DIC_SIZE 0
#endif
#ifdef NNM_WEIGHT
#define CAND_DIC_SIZE (/* num_stroke */sizeof(uchar)+/* size X */sizeof(uchar)+\
         /* size Y */sizeof(uchar)+/* dir_stroke */sizeof(uchar)*8+\
	 /* dir_stroke_weight */sizeof(uchar)*8+\
	 CAND_STRLONG_DIC_SIZE+CAND_STRSHORT_DIC_SIZE)
#else
#define CAND_DIC_SIZE (/* num_stroke */sizeof(uchar)+/* size X */sizeof(uchar)+\
         /* size Y */sizeof(uchar)+/* dir_stroke */sizeof(uchar)*8+\
	 CAND_STRLONG_DIC_SIZE+CAND_STRSHORT_DIC_SIZE)
#endif

typedef struct{
  NnmCandFeatureRec	Cand;
  uchar			dir_fv[8][NnmREGION_NUM_Y][NnmREGION_NUM_X];
}	NnmRawFeatureRec;

typedef struct{
  NnmCandFeatureRec	Cand;
  uchar			dir_fv[8][NnmFV_REGION_Y][NnmFV_REGION_X];
}	NnmFeatureRec;

typedef struct{
  ulong			num_sample;
  ulong			code;
  NnmCandFeatureDicRec	Cand;
  uchar			dir_fv[8][NnmFV_REGION_Y][NnmFV_REGION_X];
#ifdef NNM_WEIGHT
  uchar			weight[8][NnmFV_REGION_Y][NnmFV_REGION_X];
#endif
}	NnmFeatureDicRec;

#ifdef NNM_WEIGHT
#define DIC_SIZE (/* num_sample */sizeof(ulong)+/* code */sizeof(ulong)+\
  CAND_DIC_SIZE+/* dir_fv */sizeof(uchar)*8*NnmFV_REGION_Y*NnmFV_REGION_X+\
  /* weight */sizeof(uchar)*8*NnmFV_REGION_Y*NnmFV_REGION_X)

#else
#define DIC_SIZE (/* num_sample */sizeof(ulong)+/* code */sizeof(ulong)+\
  CAND_DIC_SIZE+/* dir_fv */sizeof(uchar)*8*NnmFV_REGION_Y*NnmFV_REGION_X)
#endif

#define NNM_WEIGHT_MAX 255
#define NNM_WEIGHT_STD (NNM_WEIGHT_MAX/2)

typedef struct{
  int			fptr;
  unsigned long		code;
  NnmCandFeatureDicRec	candfv;
} NnmDicCacheRec;

#define NNM_MAX_NSTR_DIS 5

typedef struct{
  char			*fn;
  int			fd;
  int			num;
  NnmDicCacheRec        *body;
} NnmDicCache;

#endif
