/* 
   $Id: nnmCanvas.h,v 1.1.1.1 2005/06/29 22:24:41 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef NNM_CANVAS_H
#define NNM_CANVAS_H

#include	<qpixmap.h>
#include	<qtimer.h>

#include	"Nnm.h"

#define		EVENT_PEN_DOWN	0
#define		EVENT_TIMEOUT	1

class	nnmCanvas : public QWidget
{
Q_OBJECT

public:
	nnmCanvas( QWidget *parent, int timeoutMsec, int initID,
		   const char *name = 0, WFlags f = 0 );
	void			init( void );
	const NnmRawCharInfoRec	*getStroke( void );
	bool			isNull( void );

protected:
	virtual void	mousePressEvent( QMouseEvent * );
	virtual void	mouseMoveEvent( QMouseEvent * );
	virtual void	mouseReleaseEvent( QMouseEvent * );
	virtual void	paintEvent( QPaintEvent * );
	virtual void	resizeEvent( QResizeEvent * );

private:
	QPixmap			_buffer;
	NnmRawCharInfoRec	rawData;

	QTimer			*timer;

	int			id;
	int			timeoutMsec;

private slots:
	void			timeoutRecognize( void );

signals:
	void			eventHappen( int, int );
};

#endif // NNM_CANVAS_H

