/* 
   $Id: nnmSelect.cpp,v 1.1.1.1 2005/06/29 22:24:41 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* The Popup-menu for select suitable data from candidates' list */

#include	<qpainter.h>
#include	<qwidget.h>
#include	<qlayout.h>
#include	<qpushbutton.h>
#include	<qbuttongroup.h>

#include	<stdio.h>

#include	"Nnm.h"
#include	"nnmSelect.h"
#include	"moc_nnmSelect.cpp"

#define		BTN_W	24
#define		BTN_H	19
#define		INNER_W	( BTN_W - 2 )
#define		INNER_H	( BTN_H - 2 )

nnmSelectButton::nnmSelectButton( QWidget *parent, char *name )
			: QFrame( parent, name )
{
	setFixedSize( BTN_W, BTN_H );
	setFrameStyle( Box | Plain );

	button = new QPushButton( this );
	button->setFixedSize( INNER_W, INNER_H );
	button->setFlat( true );
}

nnmSelect::nnmSelect( Nunome *parent, const char *name, WFlags f )
			: QFrame( parent, name, f )
{
	int	count = 0;

	setFixedSize( COLS_SELECT * BTN_W, ( ROWS_SELECT+1 ) * BTN_H );

	QBoxLayout	*topLayout	= new QVBoxLayout( this );
	QGridLayout	*top		= new QGridLayout( topLayout, 4, 6 );
	QBoxLayout	*bottom 	= new QHBoxLayout( topLayout );

	QButtonGroup *group = new QButtonGroup( this );
	group->hide();

	for ( int row = 0; row < ROWS_SELECT; row++ )	{
		for ( int col = 0; col < COLS_SELECT; col++ )	{
			selectButton[count] = new nnmSelectButton( this );
			top->addWidget( selectButton[count], row, col );
			group->insert( selectButton[count]->button );
			count++;
		}
	}

	connect( group, SIGNAL( clicked( int ) ),
		 this, SLOT( selection( int ) ) );

	QPushButton *btn1 = new QPushButton( this );
	btn1->setFixedSize( BTN_W * 2, BTN_H );
	btn1->setText( tr( "Other" ) );
	connect( btn1, SIGNAL( clicked() ), this, SLOT( changePage() ) );
	bottom->addWidget( btn1 );

	QPushButton *btn2 = new QPushButton( this );
	btn2->setFixedSize( BTN_W * 2, BTN_H );
	btn2->setText( tr( "Cancel" ) );
	connect( btn2, SIGNAL( clicked() ), this, SLOT( hide() ) );
	bottom->addWidget( btn2 );

	QPushButton *btn3 = new QPushButton( this );
	btn3->setFixedSize( BTN_W * 2, BTN_H );
	btn3->setText( tr( "Del" ) );
	connect( btn3, SIGNAL( clicked() ), this, SLOT( clearCandidate() ) );
	bottom->addWidget( btn3 );

	topLayout->activate();

	hide();
}

void	nnmSelect::start( nnmCandidate *target )
{
	targetCandidate = target;
	page = 0;

	showPage();
	show();
}

void	nnmSelect::showPage( void )
{
	int	i;
	int	pos;

	for ( i = 0, pos = page * NUM_IN_PAGE;
	      i < NUM_IN_PAGE;
	      i++, pos++ )	{
		selectButton[i]->button->setText( QString(
				QChar( ( short )targetCandidate->list[pos] )
							 ) );
	}
}

void	nnmSelect::selection( int pos )
{
	pos += ( page * NUM_IN_PAGE );
	targetCandidate->setSuitable( targetCandidate->list[pos] );

	hide();
}

void	nnmSelect::changePage( void )
{
	page = ( page ) ? 0 : 1;
	showPage();
}

void	nnmSelect::clearCandidate( void )
{
	targetCandidate->init();
	hide();
}
