/* 
   $Id: nnmSelect.h,v 1.1.1.1 2005/06/29 22:24:41 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef NNM_SELECT_H
#define NNM_SELECT_H

#include	<qframe.h>
#include	<qpushbutton.h>
#include	"Nnm.h"

#define		ROWS_SELECT	4
#define		COLS_SELECT	6
#define		NUM_IN_PAGE	( ROWS_SELECT * COLS_SELECT )

class	Nunome;
class	nnmCandidate;

class	nnmSelectButton : public QFrame
{
Q_OBJECT

public:
	nnmSelectButton( QWidget *widget = 0, char *name = 0 );
	QPushButton	*button;
};

class	nnmSelect : public QFrame
{
Q_OBJECT

public:
	nnmSelect( Nunome *parent, const char *name = 0, WFlags f = 0 );

	void		start( nnmCandidate *target );
	void		showPage( void );

	nnmCandidate	*targetCandidate;

private slots:
	void		selection( int pos );
	void		changePage( void );
	void		clearCandidate( void );

private:
	int		page;
	nnmSelectButton	*selectButton[NUM_IN_PAGE];
};

#include	"nunome.h"
#include	"nnmCandidate.h"

#endif // NNM_SELECT_H

