/* 
   $Id: nunome.h,v 1.1.1.1 2005/06/29 22:24:43 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef NUNOME_H
#define NUNOME_H

#include	<sys/types.h>

#include	<qframe.h>
#include	<qsocketnotifier.h>
#include	"nnmCanvas.h"
#include	"nnmCandidate.h"
#include	"nnmSelect.h"
#include	"nnmSymbol.h"

#define	PARAMETER_FILE_PATH		"/usr/local/share/nunome/.nunome"

#define	DEFAULT_SYSTEM_DICTIONARY	"/usr/local/share/nunome/nunome_uni.dic"
#define	DEFAULT_USER_DICTIONARY		"/usr/local/share/nunome/user.dic"
#define	DEFAULT_TIMEOUT_MSEC		500
#define	DEFAULT_LEARN_FLAG		true
#define	DEFAULT_SERVER_PROGRAM_PATH	"/usr/local/share/nunome/nnmsrv"
#define	DEFAULT_LEARN_PROGRAM_PATH	"/usr/local/share/nunome/nnmDicman"

class	nnmParameter
{
public:
	nnmParameter( void );

	char	*systemDictionary;
	char	*userDictionary;
	int	timeoutMsec;
	bool	learnFlag;
	char	*serverProgramPath;
	char	*learnProgramPath;
};

class	Nunome : public QFrame
{
Q_OBJECT

public:
	Nunome( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );

	void		resetState( void );
	QSize		sizeHint( void ) const { return QSize( 240, 96 ); }

private slots:
	void		clearCandidate( void );
	void		sendEnter( void );
	void		sendBackspace( void );
	void		sendSpace( void );
	void		sendAll( void );
	void		startRegist( void );
	void		startSelect( int pos );
	void		startSymbol( void );
	void		sendSymbol( void );

	void		startRecognize( void );
	void		startRecognizeByCanvas( int canvasID, int flag );

public slots:
	void		recognizeDone( void );

private:
	pid_t		startServer( char * );
	void		shiftCandidates( void );
	nnmCandidate	*getTargetCandidate( void );
	void		recognize( nnmCanvas *targetCanvas );

	nnmCanvas	*canvas[MAX_NUM_CANVAS];
	nnmCandidate	*candidate[MAX_DISP_RESULT];
	nnmSelect	*selectPanel;
	nnmSymbol	*symbolPanel;

	nnmCanvas	*lookingCanvas;
	pid_t		serverPID;
	nnmParameter	parameter;

signals:
	void	sendCode( ushort, ushort, ushort, bool, bool );
};

#endif
