/* 
   $Id: nunomeImpl.cpp,v 1.1.1.1 2005/06/29 22:24:43 leggewie Exp $

   Copyright (C) 2001-2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome-Qtopia.

   Nunome-Qtopia is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome-Qtopia is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <qapplication.h>
#include <qobject.h>
#include <qpixmap.h>
#include "nunome.h"
#include "nunomeImpl.h"

/* ICON */
static const char	*icn_xpm[] =	{
						"28 13 3 1",
						"       c None",
						".      c #000000",
						"@      c #8292FF",
						"                            ",
						"      .@        ..........  ",
						"      .@        .@@@@@@@@.@ ",
						" ............@  .@       .@ ",
						" @@@@.@@.@@@@@  ..........@ ",
						"    ........    .@@@@@@@@.@ ",
						"   .@.@ .@ .@   .@       .@ ",
						"  .@ .@ .@ .@   ..........@ ",
						" .@  .@ .@ .@   .@@@@@@@@.@ ",
						" @   .@ .@ .@   .@       .@ ",
						"     @  .@ @@   ..........@ ",
						"        .        @@@@@@@@@@ ",
						"                            "
					};

NunomeImpl::NunomeImpl()
		: input(0), icn(0), ref(0)
{
}

NunomeImpl::~NunomeImpl()
{
    delete	input;
    delete	icn;
}

QWidget	*NunomeImpl::inputMethod( QWidget *parent, Qt::WFlags f )
{
	if ( !input )	{
		input = new Nunome( parent, "nunome", f );
	}

	return input;
}

void	NunomeImpl::resetState( void )
{
	if ( input )	{
		input->resetState();
	}
}

QPixmap	*NunomeImpl::icon( void )
{
	if ( !icn )	{
		icn = new QPixmap( ( const char ** )icn_xpm );
	}

	return icn;
}

QString	NunomeImpl::name( void )
{
    return qApp->translate( "InputMethods", "Nunome" );
}

void	NunomeImpl::onKeyPress( QObject *receiver, const char *slot )
{
	if ( input )	{
		QObject::connect( input,
			SIGNAL( sendCode(ushort,ushort,ushort,bool,bool) ),
			receiver, slot );
	}
}

QRESULT	NunomeImpl::queryInterface( const QUuid &uuid,
					QUnknownInterface **iface )
{
	*iface = 0;

	if ( uuid == IID_QUnknown  ||  uuid == IID_InputMethod ) {
		*iface = this;
		addRef();
	}

	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE( NunomeImpl )
}
